import { Executor } from '../../../execution/domain';
import { QueryOptions } from '../../../query/domain';
import { IQueryBuilder } from '../../domain/services';
import { ExpressionTransaction } from './transaction';
import { Expressions } from '3xpr';
export declare class ExpressionExecute {
    private readonly builder;
    private readonly executor;
    private readonly expressions;
    constructor(builder: IQueryBuilder, executor: Executor, expressions: Expressions);
    execute(expression: string, data: any, options: QueryOptions): Promise<any>;
    executeList(expressions: string[], options: QueryOptions): Promise<any>;
    transaction(options: QueryOptions, callback: {
        (tr: ExpressionTransaction): Promise<void>;
    }): Promise<void>;
}
