import { Property } from '../../../schema/domain';
import { Sentence } from '../../domain/sentence';
import { Parameter, Expressions } from '3xpr';
import { SchemaFacade } from '../../../schema/application';
import { ISentenceBuilder } from '../../domain';
import { OperandFacade } from '../../../operand/application';
export declare class SentenceBuilder implements ISentenceBuilder {
    private readonly schemaFacade;
    private readonly operandFacade;
    private readonly expressions;
    private typeService;
    private helper;
    private solveBehaviors;
    private solveConstraints;
    private domainConfigService;
    constructor(schemaFacade: SchemaFacade, operandFacade: OperandFacade, expressions: Expressions);
    build(expression: string): Sentence;
    private createSentence;
    private createSentenceSelect;
    private createSentenceModify;
    private createSentenceDelete;
    private createSentenceAddIncludes;
    private createSentenceAddJoins;
    private createClause;
    private createMapClause;
    private createInsertClause;
    private createUpdateClause;
    private createSelectInclude;
    private createInclude;
    private solveFields;
    private createSimpleField;
    private createRelationField;
    private solveAsteriskFields;
    private addJoins;
    private createAlias;
    getPropertiesFromParameters(entityName: string, parameters: Parameter[]): Property[];
}
