"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-template-curly-in-string */
const __1 = require("../../..");
beforeAll(() => __awaiter(void 0, void 0, void 0, function* () {
    require('dotenv').config({ path: './config/countries.env' });
    yield __1.orm.init('./config/countries.yaml');
}));
describe('group', () => {
    const context = JSON.parse('{}');
    test('normalize', () => {
        expect(__1.orm.normalize('Countries.filter(p=> p.region == "Americas").map(p=> {result:count(1)})')).toStrictEqual('Countries.map(p=>{result:count(1)}).filter(p=>(p.region==Americas))');
        expect(__1.orm.normalize('Countries.map(p=> {region:p.region,countries:count(1)})')).toStrictEqual('Countries.map(p=>{region:p.region,countries:count(1)})');
        expect(__1.orm.normalize('Countries.map(p=> {region:p.region,max:max(p.latitude)})')).toStrictEqual('Countries.map(p=>{region:p.region,max:max(p.latitude)})');
        expect(__1.orm.normalize('Countries.map(p=> {region:p.region,min:min(p.latitude)})')).toStrictEqual('Countries.map(p=>{region:p.region,min:min(p.latitude)})');
        expect(__1.orm.normalize('Countries.map(p=> {region:p.region,avg:avg(p.latitude)})')).toStrictEqual('Countries.map(p=>{region:p.region,avg:avg(p.latitude)})');
    });
    test('model', () => {
        expect(__1.orm.model('Countries.filter(p=> p.region == "Americas").map(p=> {result:count(1)})')).toStrictEqual([{ 'name': 'result', 'type': 'integer' }]);
        expect(__1.orm.model('Countries.map(p=> {region:p.region,countries:count(1)})')).toStrictEqual([{ 'name': 'region', 'type': 'string' }, { 'name': 'countries', 'type': 'integer' }]);
        expect(__1.orm.model('Countries.map(p=> {region:p.region,max:max(p.latitude)})')).toStrictEqual([{ 'name': 'region', 'type': 'string' }, { 'name': 'max', 'type': 'any' }]);
        expect(__1.orm.model('Countries.map(p=> {region:p.region,min:min(p.latitude)})')).toStrictEqual([{ 'name': 'region', 'type': 'string' }, { 'name': 'min', 'type': 'any' }]);
        expect(__1.orm.model('Countries.map(p=> {region:p.region,avg:avg(p.latitude)})')).toStrictEqual([{ 'name': 'region', 'type': 'string' }, { 'name': 'avg', 'type': 'number' }]);
    });
    test('parameters', () => {
        expect(__1.orm.parameters('Countries.filter(p=> p.region == "Americas").map(p=> {result:count(1)})')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.map(p=> {region:p.region,countries:count(1)})')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.map(p=> {region:p.region,max:max(p.latitude)})')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.map(p=> {region:p.region,min:min(p.latitude)})')).toStrictEqual([]);
        expect(__1.orm.parameters('Countries.map(p=> {region:p.region,avg:avg(p.latitude)})')).toStrictEqual([]);
    });
    test('constraints', () => {
        expect(__1.orm.constraints('Countries.filter(p=> p.region == "Americas").map(p=> {result:count(1)})')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.map(p=> {region:p.region,countries:count(1)})')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.map(p=> {region:p.region,max:max(p.latitude)})')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.map(p=> {region:p.region,min:min(p.latitude)})')).toStrictEqual({ "entity": "Countries", "constraints": [] });
        expect(__1.orm.constraints('Countries.map(p=> {region:p.region,avg:avg(p.latitude)})')).toStrictEqual({ "entity": "Countries", "constraints": [] });
    });
    test('getInfo', () => {
        expect(__1.orm.getInfo('Countries.filter(p=> p.region == "Americas").map(p=> {result:count(1)})', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT COUNT(1) AS result FROM Countries c  WHERE c.region = 'Americas' ", "children": [] });
        expect(__1.orm.getInfo('Countries.map(p=> {region:p.region,countries:count(1)})', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.region AS region, COUNT(1) AS countries FROM Countries c  GROUP BY c.region ", "children": [] });
        expect(__1.orm.getInfo('Countries.map(p=> {region:p.region,max:max(p.latitude)})', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.region AS region, MAX(c.latitude) AS max FROM Countries c  GROUP BY c.region ", "children": [] });
        expect(__1.orm.getInfo('Countries.map(p=> {region:p.region,min:min(p.latitude)})', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.region AS region, MIN(c.latitude) AS min FROM Countries c  GROUP BY c.region ", "children": [] });
        expect(__1.orm.getInfo('Countries.map(p=> {region:p.region,avg:avg(p.latitude)})', { stage: 'stage1' })).toStrictEqual({ "entity": "Countries", "dialect": "MySQL", "source": "dataSource1", "sentence": "SELECT c.region AS region, AVG(c.latitude) AS avg FROM Countries c  GROUP BY c.region ", "children": [] });
    });
});
//# sourceMappingURL=group.test.js.map